package ru.dbotthepony.mc.otm.client.screen.panels

import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen
import ru.dbotthepony.mc.otm.container.ItemFilterNetworkSlot
import ru.dbotthepony.mc.otm.container.ItemFilterSlotPacket
import ru.dbotthepony.mc.otm.network.MenuNetworkChannel

open class FilterSlotPanel(
	screen: MatteryScreen<*>,
	parent: EditablePanel?,
	val slot: ItemFilterNetworkSlot,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = REGULAR_DIMENSIONS,
	height: Float = REGULAR_DIMENSIONS
) : AbstractSlotPanel(screen, parent, x, y, width, height) {
	override fun getItemStack(): ItemStack {
		return slot.get()
	}

	override fun mouseClickedInner(mouse_x: Double, mouse_y: Double, mouse_click_type: Int): Boolean {
		if (screen.menu.carried.isEmpty) {
			MenuNetworkChannel.sendToServer(ItemFilterSlotPacket(slot.networkID, ItemStack.EMPTY))
		} else {
			MenuNetworkChannel.sendToServer(ItemFilterSlotPacket(slot.networkID, screen.menu.carried))
		}

		return true
	}
}
