package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.entity.player.Player
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.block.entity.AndroidStationBlockEntity
import ru.dbotthepony.mc.otm.capability.MatteryPlayerCapability
import ru.dbotthepony.mc.otm.capability.MatteryCapability
import ru.dbotthepony.mc.otm.registry.MMenus

private class AndroidStationContainer(player: Player) : SimpleContainer(1) {
	var android: MatteryPlayerCapability? = null

	init {
		player.getCapability(MatteryCapability.MATTERY_PLAYER).ifPresent {
			android = it
			setItem(0, it.batteryItemStack)
		}
	}
}

private class AndroidBatterySlot(container: AndroidStationContainer, index: Int) : BatterySlot(container, index) {
	val android: MatteryPlayerCapability? = container.android

	override fun set(stack: ItemStack) {
		super.set(stack)
		android?.batteryItemStack = stack
	}
}

class AndroidStationMenu @JvmOverloads constructor(
	containerID: Int,
	inventory: Inventory,
	tile: AndroidStationBlockEntity? = null
) : MatteryPoweredMenu(MMenus.ANDROID_STATION, containerID, inventory, tile) {
	val androidBattery: MatterySlot = AndroidBatterySlot(AndroidStationContainer(inventory.player), 0)

	override val storageSlots = listOf(addSlot(androidBattery))

	init {
		addInventorySlots()
	}
}
