package ru.dbotthepony.mc.otm.tests

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import ru.dbotthepony.mc.otm.core.Fraction
import ru.dbotthepony.mc.otm.menu.data.FractionDataContainer

object NetworkingTests {
	@Test
	@DisplayName("Test FractionDataContainer store/load")
	fun fraction() {
		val container = FractionDataContainer()
		var frac = Fraction(18, 4)

		container.value = frac
		container.handle(container.makePacket())
		assert(container.value.compareTo(frac) == 0) { "${container.value} != $frac" }

		frac = Fraction(2_000_000, 1)

		container.value = frac
		container.handle(container.makePacket())
		assert(container.value.compareTo(frac) == 0) { "${container.value} != $frac" }
	}
}
